window.Gleam.initSearch([{"doc":"facquest","title":"facquest","content":"# facquest\n\n[![Package Version](https://img.shields.io/hexpm/v/facquest)](https://hex.pm/packages/facquest)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/facquest/)\n\n&gt; ⚠️ WARNING: This package has not been thoroughly tested yet, please report any bugs you run into. I will work on adding tests in the future but the version you are currently looking at with this warning was made in constrained time to use in a project\n\n## Installation\n\nThis package can be added to your Gleam project:\n\n```sh\ngleam add facquest\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/facquest&gt;.\n\n## Usage\n\n&gt; This package has not been documented, have a look in the [test](./test/) folder for more examples.\n\n```gleam\nimport facquest.{type FacquestResponse}\nimport facquest/core.{Json, Url}\nimport gleam/dynamic\nimport gleam/io\nimport gleeunit/should\n\npub type PartialProduct {\n  PartialProduct(id: Int, title: String)\n}\n\npub fn main() {\n  let decoder =\n    dynamic.decode2(\n      PartialProduct,\n      dynamic.field(&quot;id&quot;, dynamic.int),\n      dynamic.field(&quot;title&quot;, dynamic.string),\n    )\n\n  let client =\n    facquest.new(\n      base_url: Url(&quot;https://dummyjson.com/&quot;),\n      headers: [],\n      timeout: facquest.default_timeout,\n    )\n\n  client\n  |&gt; facquest.get(&quot;/products/1&quot;, expecting: Json(decoder), options: [])\n  |&gt; should.be_ok\n  |&gt; fn(res: FacquestResponse(PartialProduct)) { res.body }\n  |&gt; io.debug\n}\n\n\n// Output: PartialProduct(1, &quot;iPhone 9&quot;)\n```\n\n## Why should I use this?\n\nYou don&#39;t need to, [Hackney](https://github.com/gleam-lang/hackney) is probably enough for whatever you are doing but if you need a bit more configuration options or an axios-like interface, this is for you.\n\n&gt; NOTE: part of the hackney bindings were taken from the official Gleam hackney bindings and modified\n","url":"index.html"},{"doc":"facquest/hackney","title":"CrlCacheOptions","content":"pub type CrlCacheOptions {\n  SslCrlCache(SslCrlCacheOptions)\n}\n\nSslCrlCache(SslCrlCacheOptions)\n\n\nSynonyms:\nfacquest/hackney.CrlCacheOptions\nfacquest/hackney CrlCacheOptions","url":"facquest/hackney.html#CrlCacheOptions"},{"doc":"facquest/hackney","title":"CrlCheckMode","content":"pub type CrlCheckMode {\n  Peer\n}\n\nPeer\n\n\nSynonyms:\nfacquest/hackney.CrlCheckMode\nfacquest/hackney CrlCheckMode","url":"facquest/hackney.html#CrlCheckMode"},{"doc":"facquest/hackney","title":"Error","content":"pub type Error {\n  InvalidUtf8Response\n  Other(Dynamic)\n}\n\nInvalidUtf8Response\n\n\nOther(Dynamic)\n\n\nSynonyms:\nfacquest/hackney.Error\nfacquest/hackney Error","url":"facquest/hackney.html#Error"},{"doc":"facquest/hackney","title":"HackneyOption","content":"pub type HackneyOption {\n  Async\n  FollowRedirect(Bool)\n  MaxConnections(Int)\n  MaxRedirect(Int)\n  SSLOptions(List(SSLOption))\n  Timeout(Int)\n  WithBody(Bool)\n}\n\nAsync\n You probably DO NOT want to use this option. It is only here for compatibility\n\nFollowRedirect(Bool)\n\n\nMaxConnections(Int)\n\n\nMaxRedirect(Int)\n\n\nSSLOptions(List(SSLOption))\n\n\nTimeout(Int)\n\n\nWithBody(Bool)\n\n\nSynonyms:\nfacquest/hackney.HackneyOption\nfacquest/hackney HackneyOption","url":"facquest/hackney.html#HackneyOption"},{"doc":"facquest/hackney","title":"Options","content":"pub type Options =\n  List(HackneyOption)\n\n\nSynonyms:\nfacquest/hackney.Options\nfacquest/hackney Options","url":"facquest/hackney.html#Options"},{"doc":"facquest/hackney","title":"SSLOption","content":"pub type SSLOption {\n  Cacertfile(String)\n  CrlCheck(CrlCheckMode)\n  CrlCache(CrlCacheOptions)\n  Verify(SSLVerifyMode)\n  Versions(List(String))\n}\n\nCacertfile(String)\n\n\nCrlCheck(CrlCheckMode)\n\n\nCrlCache(CrlCacheOptions)\n\n\nVerify(SSLVerifyMode)\n\n\nVersions(List(String))\n\n\nSynonyms:\nfacquest/hackney.SSLOption\nfacquest/hackney SSLOption","url":"facquest/hackney.html#SSLOption"},{"doc":"facquest/hackney","title":"SSLVerifyMode","content":"pub type SSLVerifyMode {\n  VerifyNone\n  VerifyPeer\n  VerifyPeerStrict\n}\n\nVerifyNone\n\n\nVerifyPeer\n\n\nVerifyPeerStrict\n\n\nSynonyms:\nfacquest/hackney.SSLVerifyMode\nfacquest/hackney SSLVerifyMode","url":"facquest/hackney.html#SSLVerifyMode"},{"doc":"facquest/hackney","title":"SslCrlCacheOptions","content":"pub type SslCrlCacheOptions {\n  Internal(List(SslCrlInternalCacheOptions))\n}\n\nInternal(List(SslCrlInternalCacheOptions))\n\n\nSynonyms:\nfacquest/hackney.SslCrlCacheOptions\nfacquest/hackney SslCrlCacheOptions","url":"facquest/hackney.html#SslCrlCacheOptions"},{"doc":"facquest/hackney","title":"SslCrlInternalCacheOptions","content":"pub type SslCrlInternalCacheOptions {\n  Http(Int)\n}\n\nHttp(Int)\n\n\nSynonyms:\nfacquest/hackney.SslCrlInternalCacheOptions\nfacquest/hackney SslCrlInternalCacheOptions","url":"facquest/hackney.html#SslCrlInternalCacheOptions"},{"doc":"facquest/hackney","title":"send","content":"pub fn send(\n  request req: Request(String),\n  options options: List(HackneyOption),\n) -&gt; Result(Response(String), Error)\n\nSynonyms:\nfacquest/hackney.send\nfacquest/hackney send","url":"facquest/hackney.html#send"},{"doc":"facquest/hackney","title":"send_bits","content":"pub fn send_bits(\n  request: Request(BytesBuilder),\n  options: List(HackneyOption),\n) -&gt; Result(Response(BitArray), Error)\n\nSynonyms:\nfacquest/hackney.send_bits\nfacquest/hackney send_bits","url":"facquest/hackney.html#send_bits"},{"doc":"facquest/hackney","title":"facquest/hackney","content":"","url":"facquest/hackney.html"},{"doc":"facquest/core","title":"Config","content":"pub type Config {\n  Body(OpaqueBody)\n  Headers(Pairs)\n  Queries(Pairs)\n  ClientOptions(hackney.Options)\n}\n\nBody(OpaqueBody)\n A string to use as the body of the request - not meant to be used directly, use `post`, `put`, or `patch` instead, or if necessary, `to_body`\n\nHeaders(Pairs)\n A list of headers to *prepend* to the request\n\nQueries(Pairs)\n A list of query parameters to append to the URL\n\nClientOptions(hackney.Options)\n A list of options to pass to the underlying HTTP client to control things like timeouts and redirects\n\nSynonyms:\nfacquest/core.Config\nfacquest/core Config","url":"facquest/core.html#Config"},{"doc":"facquest/core","title":"FacquestError","content":"pub type FacquestError {\n  URLParseError\n  InvalidUtf8Response\n  HackneyError(Dynamic)\n  RawDecodingError(dynamic.DecodeErrors)\n  JsonDecodingError(json.DecodeError)\n}\n\nURLParseError\n\n\nInvalidUtf8Response\n\n\nHackneyError(Dynamic)\n\n\nRawDecodingError(dynamic.DecodeErrors)\n\n\nJsonDecodingError(json.DecodeError)\n\n\nSynonyms:\nfacquest/core.FacquestError\nfacquest/core FacquestError","url":"facquest/core.html#FacquestError"},{"doc":"facquest/core","title":"FacquestResponse","content":"pub type FacquestResponse(a) {\n  FacquestResponse(status: Int, headers: Pairs, body: a)\n}\n\nFacquestResponse(status: Int, headers: Pairs, body: a)\n\n\nSynonyms:\nfacquest/core.FacquestResponse\nfacquest/core FacquestResponse","url":"facquest/core.html#FacquestResponse"},{"doc":"facquest/core","title":"OpaqueBody","content":"pub opaque type OpaqueBody\n This exists to prevent the body from being added manually to requests like Get and Delete which don&#39;t support bodies.\n Since a user cannot create an OpaqueBody, they cannot add a body to a request that doesn&#39;t support it\n\nSynonyms:\nfacquest/core.OpaqueBody\nfacquest/core OpaqueBody","url":"facquest/core.html#OpaqueBody"},{"doc":"facquest/core","title":"Opts","content":"pub type Opts =\n  List(Config)\n\n\nSynonyms:\nfacquest/core.Opts\nfacquest/core Opts","url":"facquest/core.html#Opts"},{"doc":"facquest/core","title":"Pairs","content":"pub type Pairs =\n  List(#(String, String))\n\n\nSynonyms:\nfacquest/core.Pairs\nfacquest/core Pairs","url":"facquest/core.html#Pairs"},{"doc":"facquest/core","title":"ResultResponse","content":"pub type ResultResponse(a) =\n  Result(FacquestResponse(a), FacquestError)\n\n\nSynonyms:\nfacquest/core.ResultResponse\nfacquest/core ResultResponse","url":"facquest/core.html#ResultResponse"},{"doc":"facquest/core","title":"Target","content":"pub type Target(a) {\n  Json(Decoder(a))\n  Raw(Decoder(a))\n}\n\nJson(Decoder(a))\n\n\nRaw(Decoder(a))\n\n\nSynonyms:\nfacquest/core.Target\nfacquest/core Target","url":"facquest/core.html#Target"},{"doc":"facquest/core","title":"Url","content":"pub type Url {\n  Url(String)\n  SplitUrl(\n    scheme: Scheme,\n    host: String,\n    path: String,\n    port: Option(Int),\n  )\n}\n\nUrl(String)\n\n\nSplitUrl(\n  scheme: Scheme,\n  host: String,\n  path: String,\n  port: Option(Int),\n)\n\n\nSynonyms:\nfacquest/core.Url\nfacquest/core Url","url":"facquest/core.html#Url"},{"doc":"facquest/core","title":"append_path","content":"pub fn append_path(url: Url, path: String) -&gt; Url\n\nSynonyms:\nfacquest/core.append_path\nfacquest/core append_path","url":"facquest/core.html#append_path"},{"doc":"facquest/core","title":"delete","content":"pub fn delete(\n  to url: Url,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest/core.delete\nfacquest/core delete","url":"facquest/core.html#delete"},{"doc":"facquest/core","title":"error_to_string","content":"pub fn error_to_string(err: FacquestError) -&gt; String\n Convert a FacquestError to a string for display - some errors like HackneyError are not very helpful to the end user and are logged instead\nSynonyms:\nfacquest/core.error_to_string\nfacquest/core error_to_string","url":"facquest/core.html#error_to_string"},{"doc":"facquest/core","title":"extract_body","content":"pub fn extract_body(response: FacquestResponse(a)) -&gt; a\n\nSynonyms:\nfacquest/core.extract_body\nfacquest/core extract_body","url":"facquest/core.html#extract_body"},{"doc":"facquest/core","title":"extract_headers","content":"pub fn extract_headers(\n  response: FacquestResponse(a),\n) -&gt; List(#(String, String))\n\nSynonyms:\nfacquest/core.extract_headers\nfacquest/core extract_headers","url":"facquest/core.html#extract_headers"},{"doc":"facquest/core","title":"extract_params","content":"pub fn extract_params(\n  opts: List(Config),\n  state: #(Request(String), List(HackneyOption)),\n) -&gt; #(Request(String), List(HackneyOption))\n\nSynonyms:\nfacquest/core.extract_params\nfacquest/core extract_params","url":"facquest/core.html#extract_params"},{"doc":"facquest/core","title":"extract_status_code","content":"pub fn extract_status_code(response: FacquestResponse(a)) -&gt; Int\n\nSynonyms:\nfacquest/core.extract_status_code\nfacquest/core extract_status_code","url":"facquest/core.html#extract_status_code"},{"doc":"facquest/core","title":"get","content":"pub fn get(\n  to url: Url,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest/core.get\nfacquest/core get","url":"facquest/core.html#get"},{"doc":"facquest/core","title":"patch","content":"pub fn patch(\n  to url: Url,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest/core.patch\nfacquest/core patch","url":"facquest/core.html#patch"},{"doc":"facquest/core","title":"post","content":"pub fn post(\n  to url: Url,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest/core.post\nfacquest/core post","url":"facquest/core.html#post"},{"doc":"facquest/core","title":"put","content":"pub fn put(\n  to url: Url,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest/core.put\nfacquest/core put","url":"facquest/core.html#put"},{"doc":"facquest/core","title":"send","content":"pub fn send(\n  method method: Method,\n  url url: Url,\n  expecting decode: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n Core function for sending requests, you would normally use the `get`, `post`, `put`, `patch`, or `delete` functions instead\nSynonyms:\nfacquest/core.send\nfacquest/core send","url":"facquest/core.html#send"},{"doc":"facquest/core","title":"to_body","content":"pub fn to_body(body: String) -&gt; Config\n Convert a string to an OpaqueBody - only use this if you are using the `send` function directly\nSynonyms:\nfacquest/core.to_body\nfacquest/core to_body","url":"facquest/core.html#to_body"},{"doc":"facquest/core","title":"url_to_string","content":"pub fn url_to_string(url: Url) -&gt; String\n\nSynonyms:\nfacquest/core.url_to_string\nfacquest/core url_to_string","url":"facquest/core.html#url_to_string"},{"doc":"facquest/core","title":"facquest/core","content":"","url":"facquest/core.html"},{"doc":"facquest","title":"Client","content":"pub opaque type Client\n\n\nSynonyms:\nfacquest.Client\nfacquest Client","url":"facquest.html#Client"},{"doc":"facquest","title":"FacquestError","content":"pub type FacquestError =\n  core.FacquestError\n\n\nSynonyms:\nfacquest.FacquestError\nfacquest FacquestError","url":"facquest.html#FacquestError"},{"doc":"facquest","title":"FacquestResponse","content":"pub type FacquestResponse(a) =\n  core.FacquestResponse(a)\n\n\nSynonyms:\nfacquest.FacquestResponse\nfacquest FacquestResponse","url":"facquest.html#FacquestResponse"},{"doc":"facquest","title":"ResultResponse","content":"pub type ResultResponse(a) =\n  core.ResultResponse(a)\n\n\nSynonyms:\nfacquest.ResultResponse\nfacquest ResultResponse","url":"facquest.html#ResultResponse"},{"doc":"facquest","title":"default_timeout","content":"pub const default_timeout: Option(Int) = Some(15_000)\n\nSynonyms:\nfacquest.default_timeout\nfacquest default_timeout","url":"facquest.html#default_timeout"},{"doc":"facquest","title":"delete","content":"pub fn delete(\n  client client: Client,\n  path path: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest.delete\nfacquest delete","url":"facquest.html#delete"},{"doc":"facquest","title":"extract_headers","content":"pub fn extract_headers(\n  opts: List(Config),\n) -&gt; List(#(String, String))\n\nSynonyms:\nfacquest.extract_headers\nfacquest extract_headers","url":"facquest.html#extract_headers"},{"doc":"facquest","title":"get","content":"pub fn get(\n  client client: Client,\n  path path: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest.get\nfacquest get","url":"facquest.html#get"},{"doc":"facquest","title":"merge_opts","content":"pub fn merge_opts(\n  client: Client,\n  opts: List(Config),\n) -&gt; List(Config)\n This is used internally to merge the client options with the request options, it is only exposed for testing purposes\nSynonyms:\nfacquest.merge_opts\nfacquest merge_opts","url":"facquest.html#merge_opts"},{"doc":"facquest","title":"new","content":"pub fn new(\n  base_url base_url: Url,\n  headers headers: List(#(String, String)),\n  timeout timeout: Option(Int),\n) -&gt; Client\n\nSynonyms:\nfacquest.new\nfacquest new","url":"facquest.html#new"},{"doc":"facquest","title":"patch","content":"pub fn patch(\n  client client: Client,\n  path path: String,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest.patch\nfacquest patch","url":"facquest.html#patch"},{"doc":"facquest","title":"post","content":"pub fn post(\n  client client: Client,\n  path path: String,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest.post\nfacquest post","url":"facquest.html#post"},{"doc":"facquest","title":"put","content":"pub fn put(\n  client client: Client,\n  path path: String,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n\nSynonyms:\nfacquest.put\nfacquest put","url":"facquest.html#put"},{"doc":"facquest","title":"send","content":"pub fn send(\n  client client: Client,\n  method method: Method,\n  path path: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FacquestResponse(a), FacquestError)\n A way to send a request with a client, you would normally want to use the convenience functions (get, post, put, patch, delete) instead\nSynonyms:\nfacquest.send\nfacquest send","url":"facquest.html#send"},{"doc":"facquest","title":"facquest","content":"","url":"facquest.html"}]);